function [ x ] = cubic( v )
%cubic filter kernel. Similar to a Gaussian, but with compact support.
%   - Frisvad, J. R., and Wyvill, G. Fast high-quality noise.
%     Proceedings of GRAPHITE 2007, pp. 119-128+311, December 2007.
%   Function by Jeppe Revall Frisvad, May 2019.
  x = 1 - (v*v')*4;
  x = max(0, x.^3);
end

