function [ y ] = scnoise( p )
%scnoise Sparse convolution noise as explained in the following reference:
%   - Frisvad, J. R., and Wyvill, G. Fast high-quality noise.
%     Proceedings of GRAPHITE 2007, pp. 119-128+311, December 2007.
%   Function by Jeppe Revall Frisvad, May 2019.
  sources = 30;
  a = 0.8*sources^(-1/3);
  p0_int = floor(p - 0.5);
  y = 0;
  for i=uint8(0):uint8(7)
    corner = bitand([i, bitshift(i, -1), bitshift(i, -2)], uint8([1, 1, 1]));
    p_int = p0_int + double(corner);
    t = (4*sources)*abs(p_int(1) + p_int(2)*1000 + p_int(3)*576);
    rng(t, 'twister');
    for j = 0:(sources-1)
      c = a*rand(1, 1);
      if(j >= sources/2)
          c = -c;
      end;
      xi = rand(1, 3);
      x = p_int + xi;
      y = y + c*cubic(x - p);
    end
  end
end

